# Generated by sila2.code_generator; sila2.__version__: 0.12.2
from __future__ import annotations

from abc import ABC, abstractmethod
from typing import TYPE_CHECKING

from sila2.server import FeatureImplementationBase, MetadataDict

from .influxdbcontroller_types import (
    CreateToken_Responses,
    QueryInfluxDB_Responses,
    SetBucket_Responses,
    SetOrganisation_Responses,
    SetToken_Responses,
)

if TYPE_CHECKING:
    from ...server import Server


class InfluxDBControllerBase(FeatureImplementationBase, ABC):
    parent_server: Server

    def __init__(self, parent_server: Server):
        """
        InfluxDB Controller
        """
        super().__init__(parent_server=parent_server)

    @abstractmethod
    def get_Token(self, *, metadata: MetadataDict) -> str:
        """
        Get Current InfluxDB Token

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Get Current InfluxDB Token
        """

    @abstractmethod
    def get_Organisation(self, *, metadata: MetadataDict) -> str:
        """
        Get Current InfluxDB Organisation

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Get Current InfluxDB Organisation
        """

    @abstractmethod
    def get_Bucket(self, *, metadata: MetadataDict) -> str:
        """
        Get Current InfluxDB Bucket

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Get Current InfluxDB Bucket
        """

    @abstractmethod
    def CreateToken(self, Token: str, *, metadata: MetadataDict) -> CreateToken_Responses:
        """
        Create New Token for InfluxDB


        :param Token: InfluxDB access token

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def SetToken(self, Token: str, *, metadata: MetadataDict) -> SetToken_Responses:
        """
        Set Token for InfluxDB


        :param Token: InfluxDB access token

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def SetOrganisation(self, Organisation: str, *, metadata: MetadataDict) -> SetOrganisation_Responses:
        """
        Set Organisation in InFluxDB


        :param Organisation: Name of the Organisation

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def SetBucket(self, Bucket: str, *, metadata: MetadataDict) -> SetBucket_Responses:
        """
        Set InfluxDB bucket


        :param Bucket: Name of the InfluxDB Bucket

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def QueryInfluxDB(self, Query: str, QueryResultType: str, *, metadata: MetadataDict) -> QueryInfluxDB_Responses:
        """
        Query InfluxDB in flux query language


        :param Query: Flux Query

        :param QueryResultType: Type of Query Result (JSON, Pandas Dataframe, ...)

        :param metadata: The SiLA Client Metadata attached to the call

        :return:

            - QueryResult: Result of query


        """
